package com.tdws.pandora.exceptions;

import org.jboss.logging.Logger;
import org.jboss.soa.esb.actions.AbstractActionPipelineProcessor;
import org.jboss.soa.esb.actions.ActionProcessingException;
import org.jboss.soa.esb.client.ServiceInvoker;
import org.jboss.soa.esb.helpers.ConfigTree;
import org.jboss.soa.esb.message.Message;

public class PandoraCustomServiceInvoker  extends AbstractActionPipelineProcessor  {

	private Logger logger = Logger.getLogger(PandoraCustomServiceInvoker.class);
	
	public PandoraCustomServiceInvoker(ConfigTree configTree) {
	}
	@Override
	public Message process(Message message) throws ActionProcessingException {
		logger.debug("Inside Process Method of PandoraCustomServiceInvoker: Start");
		try {
			  ServiceInvoker invoker = new ServiceInvoker("contentRoutingServices", "WalletNotificationContentRoutingService");
			  logger.debug("About to invoke Service.");
			  message.getHeader().getCall().setReplyTo(null);
			  invoker.deliverSync(message, 30000);			
			  logger.debug("Service Invoked Successfully.");
			} catch (Exception e) {
				logger.error("Error Occured while invoking service ", e);
				message.getBody().add(PandoraUtils.getErrorResponse(e));  
			} 
		logger.debug("Inside Process Method of PandoraCustomServiceInvoker: End");
			return message;
	}

	
}
