package com.tdws.pandora.exceptions;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import javax.xml.transform.TransformerException;

import org.jboss.logging.Logger;
import org.jboss.soa.esb.actions.AbstractActionPipelineProcessor;
import org.jboss.soa.esb.actions.ActionProcessingException;
import org.jboss.soa.esb.helpers.ConfigTree;
import org.jboss.soa.esb.message.Message;
import org.xml.sax.SAXException;

import com.tdws.pandora.constants.PandoraConstants;
import com.tdws.pandora.utils.ValidationUtil;



public class PandoraValidatorAction extends AbstractActionPipelineProcessor {

	private static final Logger logger = Logger.getLogger(PandoraValidatorAction.class);
	private String  xsdPath;
	private String  xslPath;
	public PandoraValidatorAction(ConfigTree configTree) {
		xsdPath = configTree.getAttribute("xsdPath");
		xslPath = configTree.getAttribute("xslPath");
		logger.info(xsdPath);
		logger.info(xslPath);
	}
	
	@Override
	public Message process(Message message) throws ActionProcessingException {
		// TODO Auto-generated method stub
		
		Map<String, String> validatorConfig = new HashMap<String, String>();
		validatorConfig.put(PandoraConstants.XSD_PATH, xsdPath);
		validatorConfig.put(PandoraConstants.XSL_PATH, xslPath);
		
		//Validate the input message
			try {
				ValidationUtil.validateMessage(message,validatorConfig);
			} catch (TransformerException e) {
				message.getBody().add(PandoraUtils.getErrorResponse(e));  
			} catch (SAXException e) {
				message.getBody().add(PandoraUtils.getErrorResponse(e));  
			} catch (IOException e) {
				message.getBody().add(PandoraUtils.getErrorResponse(e));  
			}
		
		return message;
	}

}
